#include <iostream>

// Ʒ
class Product
{
public:
	virtual void Print() = 0;  // 
	virtual Product* Clone() = 0;  // ԭģʽеĸƺ
};

// Ʒ
class ProductA : public Product
{
public:
	virtual void Print()
	{
		std::cout << "I am ProductA." << std::endl;
	}

	virtual Product* Clone()
	{
		return new ProductA(*this);  // ʹÿ캯и
	}
};

class ProductB : public Product
{
public:
	virtual void Print()
	{
		std::cout << "I am ProductB." << std::endl;
	}

	virtual Product* Clone()
	{
		return new ProductB(*this);  // ʹÿ캯и
	}
};

// 幤
class Factory
{
public:
	static Product* CreateProduct(Product* prototype)  // 
	{
		return prototype->Clone();  // ʹøƺд
	}
};

int main()
{
	// ԭͶA
	Product* prototypeA = new ProductA();

	// ʹùƷA
	Product* productA = Factory::CreateProduct(prototypeA);
	productA->Print();  //  "I am ProductA."

	// ԭͶB
	Product* prototypeB = new ProductB();

	// ʹùƷB
	Product* productB = Factory::CreateProduct(prototypeB);
	productB->Print();  //  "I am ProductB."

	return 0;
}
