#include <iostream>

// Ŀӿ
class Shape {
public:
	virtual void Draw() = 0;
};

// 
class Rectangle {
public:
	void DrawRectangle() {
		std::cout << "Drawing Rectangle." << std::endl;
	}
};

// Բ
class Circle {
public:
	void DrawCircle() {
		std::cout << "Drawing Circle." << std::endl;
	}
};

// 
class Triangle {
public:
	void DrawTriangle() {
		std::cout << "Drawing Triangle." << std::endl;
	}
};

// 
class RectangleAdapter : public Shape, private Rectangle {
public:
	void Draw() {
		DrawRectangle();
	}
};

// Բ
class CircleAdapter : public Shape, private Circle {
public:
	void Draw() {
		DrawCircle();
	}
};

// 
class TriangleAdapter : public Shape, private Triangle {
public:
	void Draw() {
		DrawTriangle();
	}
};

int main() {
	Shape* shapes[3];
	shapes[0] = new RectangleAdapter();
	shapes[1] = new CircleAdapter();
	shapes[2] = new TriangleAdapter();

	for (int i = 0; i < 3; i++)
		shapes[i]->Draw();

	return 0;
}