#include <iostream>
#include <string>

// Ŀӿ
class Target {
public:
	virtual void Request() = 0;
};

// Ҫ
class Adaptee {
public:
	void SpecificRequest() {
		std::cout << "SpecificRequest of Adaptee." << std::endl;
	}
};

// 
class Adapter : public Target, private Adaptee {
public:
	void Request() {
		SpecificRequest();
	}
};

int main() {
	Target* target = new Adapter();
	target->Request();
	return 0;
}